'
' PBCARDS.BAS, demo and test program for PBCARDS.INC, a card game
' custom control for PB/DLL compiler. See PBCARDS.INC for more info.
'
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "PBCARDS.INC"   'custom control card game include file
#RESOURCE "PBCARDS.PBR"  'holds bitmaps, icon and version info for above control

GLOBAL hGame AS LONG, Event AS LONG, gLastSel AS LONG, gDrag AS LONG, gDragCard AS LONG
GLOBAL gOldCard AS LONG, gTopCard AS LONG, gPileSymbol AS LONG
GLOBAL gCard()   AS CardData  'array to hold card data
GLOBAL gPile()   AS PileData  'array to hold pile data
GLOBAL gShCard() AS LONG      'array to hold shuffled card number

DECLARE CALLBACK FUNCTION DlgProc
DECLARE SUB CardClick(Byval a AS LONG)
DECLARE SUB DealCards
DECLARE SUB DrawCardBacks(BYVAL hWnd AS LONG)
DECLARE SUB DrawCardFaces(BYVAL hWnd AS LONG)
DECLARE SUB DrawCardHolders
DECLARE SUB DrawShuffled(BYVAL hWnd AS LONG)
DECLARE SUB ShuffleDeck
DECLARE SUB StartGame

'
' Create dialog and controls
'
FUNCTION WINMAIN (BYVAL hInst AS LONG, BYVAL hPrevInstance AS LONG, _
                  lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

  LOCAL hDlg AS LONG, hIcon AS LONG, I AS LONG, J AS LONG, K AS LONG

  DIALOG NEW 0, "PBcards demo", , , 316, 246, _
             %WS_CAPTION OR %WS_SYSMENU OR %WS_MINIMIZEBOX , TO hDlg

  'Set default icon from the resource file
  hIcon = LoadIcon(hInst, "PROGRAM")
  DIALOG SEND hDlg, %WM_SETICON, %ICON_BIG, hIcon
  DIALOG SEND hDlg, %WM_SETICON, %ICON_SMALL, hIcon

  CONTROL ADD CHECKBOX, hDlg, 10,  "&Light background",  236,   8, 75, 14
  CONTROL ADD BUTTON, hDlg, 18,    "&Hulp?",             236,  98, 75, 14
  CONTROL ADD BUTTON, hDlg, 19,    "&Match pairs, Game", 236, 128, 75, 14
  CONTROL ADD BUTTON, hDlg, 20,    "&Draw bonus screen", 236, 148, 75, 14
  CONTROL ADD BUTTON, hDlg, 21,    "Draw &backs",        236, 168, 75, 14
  CONTROL ADD BUTTON, hDlg, 22,    "Draw &cards",        236, 188, 75, 14
  CONTROL ADD BUTTON, hDlg, 23,    "&Shuffle",           236, 208, 75, 14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "E&xit",          236, 228, 75, 14

  hGame = CreateCardGame(hDlg, 50, 4, 4, 224, 238, _
                         %WS_CHILD OR %WS_VISIBLE, %WS_EX_CLIENTEDGE, 1)
  SendMessage hGame, %CRD_SETDECKWIPEX, 0, 8
  SendMessage hGame, %CRD_SETDECKWIPEY, 0, 8


  'INITIATE CARD GAME ARRAYS
  REDIM gCard(51), gShCard(51), gPile(9)

  'CARD DATA
  gLastSel = 1
  FOR I = 0 TO 51
     gCard(I).Number  = I + 1
     gCard(I).Face    = (I \ 13) + 1
     gCard(I).Value   = (I MOD 13) + 1
     gCard(I).BackNum = gLastSel  '4 card backs in resource file (0-3)
     gCard(I).Pile    = 4
     gShCard(I)       = I
  NEXT

  'CARD PILE LOCATIONS
  K = 0
  FOR I = 0 TO 1
     FOR J = 0 TO 3
        gPile(K).r.nLeft = 81 * J + 8
        gPile(K).r.nRight = gPile(K).r.nLeft + 71
        gPile(K).r.nTop = 104 * I + 8
        gPile(K).r.nBottom = gPile(K).r.nTop + 96
        INCR K
     NEXT
  NEXT

  'DISCARD PILE LOCATION
  gPile(8).r.nLeft   = gPile(5).r.nLeft - 40
  gPile(8).r.nRight  = gPile(5).r.nRight - 40
  gPile(8).r.nTop    = gPile(7).r.nBottom + 16
  gPile(8).r.nBottom = gPile(8).r.nTop + 96

  'DECK LOCATION
  gPile(9).r.nLeft   = gPile(7).r.nLeft - 40
  gPile(9).r.nRight  = gPile(7).r.nRight - 40
  gPile(9).r.nTop    = gPile(6).r.nBottom + 16
  gPile(9).r.nBottom = gPile(9).r.nTop + 96

  DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION

'
' Main dialog procedure
'
CALLBACK FUNCTION DlgProc

  SELECT CASE CBMSG
     CASE %WM_INITDIALOG
        LOCAL I AS LONG, wCard AS LONG, wPile AS LONG, pt AS POINTAPI, txt AS STRING
        STATIC xPos AS LONG, yPos AS LONG, ptOrg AS POINTAPI, ptNew AS POINTAPI        

     CASE %WM_COMMAND
        SELECT CASE LOWRD(CBWPARAM)
           CASE 10
              IF SendMessage(GetDlgItem(CBHNDL, 10), %BM_GETCHECK, 0, 0) THEN
                 SendMessage hGame, %CRD_SETBKCOLOR, RGB(0, 192, 255), 0
              ELSE
                 SendMessage hGame, %CRD_SETBKCOLOR, RGB(0, 128, 0), 0
              END IF
              Select Case Event
                 CASE 0 : SendMessage hGame, %CRD_REFRESH, 0, 0 'nothing started, simply redraw game board
                 CASE 1 : SendMessage CBHNDL, %WM_COMMAND, MAKLNG(20, 0), 0 'trigger Bonus screen button..
                 CASE 2 : SendMessage CBHNDL, %WM_COMMAND, MAKLNG(21, 0), 0 'trigger Card backs button..
                 CASE 3 : SendMessage CBHNDL, %WM_COMMAND, MAKLNG(22, 0), 0 'trigger Draw cards button..
                 CASE 4 : SendMessage CBHNDL, %WM_COMMAND, MAKLNG(23, 0), 0 'trigger Shuffle button..
                 CASE 5 : SendMessage CBHNDL, %WM_COMMAND, MAKLNG(19, 0), 0 'trigger Start game button..
              END SELECT

           CASE 18
              txt = "Demo shows basic use of PBcards.inc" + $CRLF + $CRLF + _
                    "Shuffle:" + $CRLF + _
                    "Shuffles and draws all cards. Click bottom card to test select." + $CRLF + $CRLF + _
                    "Draw cards:" + $CRLF + _
                    "Draws all card faces. Click bottom card to test dragging." + $CRLF + $CRLF + _
                    "Draw backs:" + $CRLF + _
                    "Draws card backs and piles. Click card back to select." + $CRLF + $CRLF + _
                    "Draw bonus screen" + $CRLF + _
                    "Draws built-in bonus screen procedure." + $CRLF + $CRLF + _
                    "Match pairs, Game" + $CRLF + _
                    "Simple card game. Click on pairs to move to discard pile. Click on deck to deal cards."
              MessageBox hGame, _
                         txt & CHR$(0), _
                         "PBcards hulp.." & CHR$(0), %MB_OK OR %MB_ICONASTERISK
              
           CASE 19 : Event = 5 : StartGame

           CASE 20 : Event = 1
              SendMessage hGame, %CRD_CLEAR, 0, 0
              DrawBonusScreen hGame
              MessageBox hGame, _
                         "Congratulations" + $CRLF + "You are a winner!" & CHR$(0), _
                         "PBcards" & CHR$(0), %MB_OK OR %MB_ICONASTERISK

           CASE 21 : Event = 2
              DrawCardBacks hGame
              DrawFrame hGame, gCard(gLastSel), 1, RGB(255,255,0)

           CASE 22 : Event = 3 : DrawCardFaces hGame
           CASE 23 : Event = 4 : DrawShuffled hGame
           CASE %IDCANCEL : DIALOG END CBHNDL
        END SELECT

     CASE %CRD_LBUTTONDOWN, %CRD_LBUTTONDBLCLK
           pt.x = LOWRD(CBLPARAM) : pt.y = HIWRD(CBLPARAM)

           IF Event = 5 THEN 'GAME IS RUNNING
              FOR I = 0 TO 7 'check piles
                 IF PtInRect(gPile(I).r, pt.x, pt.y) THEN
                    IF gPile(I).CardCount THEN CardClick gPile(I).TopCard
                    EXIT FUNCTION
                 END IF
              NEXT

              IF gTopCard = 52 THEN EXIT FUNCTION
              IF PtInRect(gCard(gShCard(gTopCard)).r, pt.x, pt.y) THEN
                 DealCards
                 EXIT FUNCTION
              END IF

              IF PtInRect(gPile(8).r, pt.x, pt.y) THEN
                 IF gOldCard > -1 THEN
                    gCard(gOldCard).Selected = 0                 'unselect previous card
                    DrawCardInc hGame, gCard(gOldCard), 1        'redraw it
                    gOldCard = -1                                'reset OldCard variable
                 END IF
              END IF

           ELSEIF Event = 4 THEN
              FOR I = 51 TO 0 STEP - 1 'check shuffled cards
                 IF PtInRect(gCard(gShCard(I)).r, pt.x, pt.y) THEN
                    wCard = gShCard(I)
                    wPile = gCard(wCard).Pile

                    IF gCard(wCard).PosInPile = gPile(wPile).CardCount THEN
                       gCard(wCard).Selected = NOT gCard(wCard).Selected
                       DrawCardInc hGame, gCard(wCard), 1
                    END IF

                    EXIT FUNCTION
                 END IF
              NEXT

           ELSEIF Event = 3 THEN
              GetCursorPos ptOrg
              FOR I = 51 TO 0 STEP - 1 'check non-shuffled cards
                 IF PtInRect(gCard(I).r, pt.x, pt.y) THEN
                    wPile = gCard(I).Pile
                    IF gCard(I).PosInPile = gPile(wPile).CardCount THEN
                       IF gCard(I).Drag THEN
                          SetCapture hGame
                          gDrag = 1 : gDragCard = I
                          xPos = gCard(I).r.nLeft : yPos = gCard(I).r.nTop
                          WipeCard hGame, gCard(I), 0
                          DrawCardInc hGame, gCard(I - 1), 0
                          StartDrag hGame, gCard(I)
                          EXIT FUNCTION
                       END IF

                    END IF
                    EXIT FUNCTION
                 END IF
              NEXT
           ELSEIF Event = 2 THEN
              FOR I = 0 TO 3 'check piles
                 IF PtInRect(gCard(I).r, pt.x, pt.y) THEN
                    DrawFrame hGame, gCard(gLastSel), 0, 0
                    DrawFrame hGame, gCard(I), 1, RGB(255,255,0)
                    gLastSel = I
                    EXIT FUNCTION
                 END IF
              NEXT

           END IF

     CASE %CRD_MOUSEMOVE
        IF gDrag = 1 THEN
           GetCursorPos ptNew
           DoDrag hGame, xPos + (ptNew.x - ptOrg.x), yPos + (ptNew.y - ptOrg.y)
        END IF

     CASE %CRD_LBUTTONUP
        IF gDrag = 1 THEN
           ReleaseCapture
           DrawCardInc hGame, gCard(gDragCard), 1
           EndDrag hGame
           gDrag = 0
        END IF

  END SELECT

END FUNCTION

'
' Draw card backs
'
SUB DrawCardBacks(BYVAL hWnd AS LONG)
  LOCAL I AS LONG

  SendMessage hGame, %CRD_CLEAR, 0, 0

  FOR I = 0 TO 3           'deal cards
     gCard(I).BackNum  = I '4 card backs in resource file (0-3)
     gCard(I).Drag     = 0
     gCard(I).FaceDown = 1
     gCard(I).Pile     = I
     gCard(I).r        = gPile(I).r

     DrawCardInc hGame, gCard(I), 0
  NEXT I

  FOR I = 4 TO 7           'deal cards
     DrawCardHolderInc hGame, gPile(I).r, I - 4
  NEXT I

  SendMessage hGame, %CRD_REFRESH, 0, 0
END SUB

'
' Draw card faces
'
SUB DrawCardFaces(BYVAL hWnd AS LONG)
  LOCAL I AS LONG, J AS LONG, K AS LONG

  SendMessage hGame, %CRD_CLEAR, 0, 0

  FOR I = 0 TO 51             'reset selection status
    gCard(I).Selected    = 0
  NEXT

  FOR I = 0 TO 3          'deal cards
    gPile(I).CardCount = 0
    FOR J = 0 TO 12
      gCard(K).Drag      = 1
      gCard(K).FaceDown  = 0
      gCard(K).Pile      = I
      gCard(K).PosInPile = J + 1
      gCard(K).r         = gPile(I).r
      gCard(K).r.nTop    = 8 + J * 22
      gCard(K).r.nBottom = gCard(K).r.nTop + 96
     
      DrawCardInc hGame, gCard(K), 0
      INCR gPile(I).CardCount
      INCR K
    NEXT J
  NEXT I

  SendMessage hGame, %CRD_REFRESH, 0, 0

END SUB

'
' draw shuffled deck
'
SUB DrawShuffled(BYVAL hWnd AS LONG)
  LOCAL I AS LONG, J AS LONG, K AS LONG, L AS LONG

  ShuffleDeck
  SendMessage hGame, %CRD_CLEAR, 0, 0

  FOR I = 0 TO 51             'reset selection status
    gCard(I).Selected    = 0
  NEXT

  FOR I = 0 TO 3          'deal cards
    gPile(I).CardCount = 0
    FOR J = 0 TO 12
      L = gShCard(K)
      gCard(L).Drag      = 0
      gCard(L).FaceDown  = 0
      gCard(L).Pile      = I
      gCard(L).PosInPile = J + 1
      gCard(L).r         = gPile(I).r
      gCard(L).r.nTop    = 8 + J * 22
      gCard(L).r.nBottom = gCard(L).r.nTop + 96

      DrawCardInc hGame, gCard(L), 0

      INCR gPile(I).CardCount
      INCR K
    NEXT J
  NEXT I

  SendMessage hGame, %CRD_REFRESH, 0, 0

END SUB

'
' Shuffle deck
'
SUB ShuffleDeck
  LOCAL I AS LONG, J AS LONG

  RANDOMIZE                                   'seed the random number generator
  gShCard(0) = INT((52) * RND((52)))          'start with first card
  FOR I = 1 TO 51                             'then loop through the rest
     gShCard(I) = INT((52) * RND((52)))
     FOR J = 0 TO I - 1                       'run second loop to make sure all is unique
        IF gShCard(J) = gShCard(I) THEN
           gShCard(I) = INT((52) * RND((52)))
           J = -1                             'reset J to restart this second loop
        END IF
     NEXT J
  NEXT I

  IF Event = 5 THEN 'STARTING MATCH PAIRS GAME
     'In real life, initial deal may give no matching pairs. No point in
     'allowing this here, so following is to make sure there's at least
     'one matching pair to begin with.
     FOR I = 0 TO 6
        FOR J = I + 1 TO 7
           IF gCard(gShCard(I)).Value = _
              gCard(gShCard(J)).Value THEN EXIT SUB 'match found, so exit
        NEXT
     NEXT
     ShuffleDeck 'if here, no matching pairs in first deal - shuffle again
  END IF

END SUB

'
'
'
SUB DrawCardHolders
  LOCAL I AS LONG

  FOR I = 0 TO 7
     IF gPile(I).CardCount = 0 THEN
        DrawCardHolderInc hGame, gPile(I).r, 0
     END IF
  NEXT
  IF gPile(8).CardCount = 0 THEN DrawCardHolderInc hGame, gPile(8).r, 1
  IF gPile(9).CardCount = 0 THEN DrawCardHolderInc hGame, gPile(9).r, 2

END SUB

'
' StartGame procedure
'
SUB StartGame
  LOCAL I AS LONG, J AS LONG, K AS LONG, L AS LONG

  gOldCard     = -1

  FOR I = 0 TO 9 : gPile(I).CardCount = 0 : NEXT 'reset pile count
  FOR I = 0 TO 51                        'reset and hide all cards
     gCard(I).BackNum  = gLastSel
     gCard(I).FaceDown = 0
     gCard(I).Selected = 0
     gCard(I).Pile     = 9               'all cards will end up in deck pile
  NEXT
  SendMessage hGame, %CRD_CLEAR, 0, 0
  DrawCardHolders

  ShuffleDeck

  K = 0
  FOR I = 51 TO 8 STEP -1 'draw deck pile, from bottom - up
      L = gShCard(I)
      gCard(L).Pile     = 9
      gCard(L).FaceDown = 1
      gCard(L).Selected = 0

      gCard(L).r.nLeft   = gPile(9).r.nLeft + K
      gCard(L).r.nRight  = gCard(L).r.nLeft + 71
      gCard(L).r.nTop    = gPile(9).r.nTop + K
      gCard(L).r.nBottom = gCard(L).r.nTop + 96

      DrawCardInc hGame, gCard(L), 0 'draw card in deck

      INCR gPile(9).CardCount
      IF I MOD 11 = 0 THEN K = K + 1 'for 3-D effect - incr by 2 for heigher pile..
  NEXT

  K = 0
  FOR I = 1 TO 2          'deal cards
    FOR J = 1 TO 4
      L = gShCard(K)
      gCard(L).FaceDown = 0
      gCard(L).Pile    = K
      gCard(L).r       = gPile(K).r

      DrawCardInc hGame, gCard(L), 0 'draw card

      gPile(K).CardCount = 1
      gPile(K).TopCard    = L
      INCR K
    NEXT J
  NEXT I

  gTopCard = 8

  SendMessage hGame, %CRD_REFRESH, 0, 0
  SetFocus hGame

END SUB

'
' if a pile is empty, deal a card from deck
'
SUB DealCards
  IF gTopCard = 52 THEN EXIT SUB        'no more cards in deck pile
  IF gOldCard > -1 THEN
     gCard(gOldCard).Selected = 0                 'unselect previous card
     DrawCardInc hGame, gCard(gOldCard), 1        'redraw it
     gOldCard = -1                                'reset OldCard variable
  END IF

  LOCAL I AS LONG, L AS LONG
  gPileSymbol = 2
  FOR I = 0 TO 7                        'loop through game piles
     IF gPile(I).CardCount = 0 THEN     'if anyone is empty
        L = gShCard(gTopCard)           'get shuffled card number

        gCard(L).r        = gPile(I).r  'set destination position
        gCard(L).Pile     = I           'destination pile
        gCard(L).FaceDown = 0           'now face up
        DrawCardInc hGame, gCard(L), 0

        gPile(I).CardCount = 1          'destination pile has card again
        gPile(I).TopCard = L            'this card
        DECR gPile(9).CardCount         'deck pile has one card less
        INCR gTopCard                   'next card on top in deck pile
        IF gTopCard = 52 THEN           'if deck pile is empty
           gPileSymbol = 3              'make sure symbol (red cross) is
           EXIT FOR                     'drawn in deck pile card holder
        END IF
     END IF
  NEXT

  DrawCardHolderInc hGame, gPile(9).r, gPileSymbol
  FOR I = 51 TO gTopCard STEP -1 'draw deck pile
      L = gShCard(I)
      DrawCardInc hGame, gCard(L), 0
  NEXT
  SendMessage hGame, %CRD_REFRESH, 0, 0
END SUB

'
' Handle WM_LBUTTONDOWN
'
SUB CardClick(Byval a AS LONG)

  IF gOldCard = a THEN                             'clicked same card as previous
     gCard(a).Selected = 0                         'unselect
     DrawCardInc hGame, gCard(a), 1                'and redraw card
     gOldCard = -1                                 'reset storage

  ELSEIF gOldCard = -1 THEN                        'if none selected
     gCard(a).Selected = NOT gCard(a).Selected     'select card
     DrawCardInc hGame, gCard(a), 1                'and redraw it
     gOldCard = a                                  'store card

  ELSEIF gCard(gOldCard).Value = gCard(a).Value THEN 'elseif matching pair
     gCard(gOldCard).r = gPile(8).r                  'set destination
     gCard(a).r = gPile(8).r                         'set destination
     gCard(gOldCard).Selected = 0                    'unselect previous
     DrawCardInc hGame, gCard(a), 1                  'and redraw
     DrawCardInc hGame, gCard(gOldCard), 1

     gPile(gCard(a).pile).CardCount = 0              'these piles needs new cards
     gPile(gCard(gOldCard).pile).CardCount = 0
     gCard(a).pile = 8                               'moved cards now in result pile
     gCard(gOldCard).pile = 8
     gPile(8).CardCount = gPile(8).CardCount + 2     'result pile has two more cards
     gOldCard = -1                                   'reset OldCard variable

     DrawCardHolders

     IF gPile(8).CardCount = 52 THEN              'if result pile has 52 cards,
        SendMessage GetParent(hGame), %WM_COMMAND, MAKLNG(20, 0), 0 'trigger bonus screen button..
        Event = 5 : StartGame                     'start a new game..
     ELSE
        SendMessage hGame, %CRD_REFRESH, 0, 0     'else simply redraw
     END IF

  ELSE                                            'no match
     BEEP
     gCard(gOldCard).Selected = 0                 'unselect previous card
     DrawCardInc hGame, gCard(gOldCard), 1        'redraw it
     gOldCard = -1                                'reset OldCard variable
  END IF

END SUB
